
$hwstack = 128
$swstack = 128
$framesize = 128
$regfile = "m328def.dat"
$crystal = 1000000                                          'set fuse bits to 8 MHZ internal RC and enable Division with 8

$baud = 9600
Dim Bw As Bit                                               ' bandwith in KHz ( 0= 12.5KHz or 1= 25KHz )
Bw = 1                                                      '12.5 kHz channel_s

'*******************************************************************************
$lib "glcd-Nokia3310.lib"                                   'put that lib to Bascom-AVR/Lib directory

Config Graphlcd = 128x64sed , Rst = Portb.3 , Cs1 = Portc.3 , A0 = Portc.2 , Si = Portc.0 , Sclk = Portc.1

'***************************** Program *****************************************
Initlcd
Cls
Glcdcmd 33 : Glcdcmd 190                                    'Normal Contrast

Dim Frx As Single                                           '
Dim Frx1 As Single                                          '
Dim Frxband0 As Single
Dim Frxband1 As Single
Dim Label As Single
Dim Lbtxt As String * 5

Dim Ftx As Single                                           '
Dim Ftx1 As Single

Frx = 1450000
Frx1 = Frx / 10000
Ftx = 1450000
Ftx1 = Ftx / 10000

Frxband0 = Frx
Frxband1 = 4303500

Dim Tx_ctcss As Byte
Tx_ctcss = 1                                                'Ctcss frequency(0000 - 0038 = 1 - 39); 1 = "no CTCSS"
Dim Rx_ctcss As Byte
Rx_ctcss = 1                                                'Ctcss frequency(0000 - 0038 = 1 - 39); 1 = "no CTCSS"

Dim Ctcode(39) As String * 4
Dim Ctfreq(39) As String * 5
Gosub Fillcts

Dim Rnr As Single
Dim Rnr2 As Byte
Dim Rname(17) As String * 6
Dim Rcity(17) As String * 11
Dim Rctcss(17) As Byte
Gosub Fillrepeaters

Dim Squ As Byte
Squ = 1

Dim Mod_level As Byte
Mod_level = 8

Dim Volume As Byte
Volume = 8

Dim Menunr As Byte
Menunr = 0

Dim Msqu As Byte
Msqu = 0

Dim Mvol As Byte
Mvol = 0

Dim Mmod As Byte
Mvol = 0

Dim Mscn As Byte
Mscn = 0

Dim Mctr As Byte
Mctr = 0

Dim Mctt As Byte
Mctt = 0

Dim Mmic As Byte
Mmic = 0

Dim Mfrq As Byte
Mfrq = 1

Dim Teller As Byte
Teller = 0

Dim Mbnd As Byte
Mbnd = 0

Dim Tx_bit As Bit
Tx_bit = 1                                                  'Tx_bit=0 means tranceiver receives

Dim Band As Bit
Band = 0

Dim Doscan As Bit
Doscan = 0

Dim Blocktx As Bit
Blocktx = 0

Dim Repeatersign As String * 1
Repeatersign = " "

Dim Fromrepeater As Bit
Fromrepeater = 0

Dim Sdtmf As String * 5
Sdtmf = "12345"

Tx_led Alias Portd.5
Config Tx_led = Output

Rx_led Alias Portd.6
Config Rx_led = Output

Tx_pin Alias Portd.7
Config Tx_pin = Output
Tx_pin = 1

Dtmfport Alias Portb.1
Config Dtmfport = Output

Bipbip Alias Portb.0                                        'Beeper output
Config Bipbip = Output
Bipbip = 1                                                  'no beeping

Dim Step_freq As Single                                     ', Freq1 As Single       ', Step_freq1 As Dword
Step_freq = 200

Config Single = Scientific , Digits = 4

Dim Print_once As Bit                                       '=1 sends data on UART, =0 does not send UART
Print_once = 0

Dim Scan_bit As Bit

Scan_bit = 0

Const Set_board = 1

Dim M As Byte
Cursor Off

Setfont Font10x16tt
Lcdat 1 , 1 , " 2m TRX"
Setfont Font8x8
Lcdat 3 , 1 , " BY JA7LGC"

Setfont Font5x5


'For M = 175 To 190                                          'slow turn-on on LCD
'   Glcdcmd 33 : Glcdcmd M
 '  Waitms 200
'Next
Glcdcmd 33 : Glcdcmd 190
Wait 2

Initlcd
Cls

Enk1 Alias Pind.3                                           'set encoder pins
Enk2 Alias Pind.2
Enk3 Alias Pind.4

Config Enk1 = Input
Config Enk2 = Input
Config Enk3 = Input
Portd.4 = 1
Portd.2 = 1
Portd.3 = 1

Rx_pin Alias Pinb.2                                         'Squelch output from DRA818
Config Rx_pin = Input                                       '0=receiving a signal, 1=no signal on receive
Rx_pin = 1

Ptt Alias Pinb.4
Config Ptt = Input
Ptt = 1

Config Timer0 = Timer , Prescale = 1

Dim B2 As Byte
Enable Interrupts

Config Int0 = Falling
Config Int1 = Falling

Enable Int0
Enable Int1

On Int0 Enkoder_sub1
On Int1 Enkoder_sub2

'enable wake up from Powerdown with encoder or encoder button
Pcicr.2 = 1
Pcmsk2 = &B00011100

'wake-up from powerdown with PTT
Pcicr.0 = 1
Pcmsk0.4 = 1                                                'na PCINT4

Print_once = 1                                              'at powerup send data to DRA module

Gosub Ledice_sub

Do
  If Ptt = Tx_bit Then                                      'needed to enable correct data sending to DRA818
    If Mfrq = 0 Then
      Mfrq = 1
      Mscn = 0
      Mbnd = 0
      Msqu = 0
      Mvol = 0
      Mmod = 0
      Mctt = 0
      Mctr = 0
      Menunr = 0
      While Ptt = 0
      Wend
    Else
      Gosub Ledice_sub
      Gosub Printlcd
    End If
  End If

  If Tx_bit = 0 Then
    If Rx_pin = 0 Then Rx_led = 1 Else Rx_led = 0
  End If

  If Rx_led = 1 Or Tx_led = 1 Then
    Doscan = 0
  End If

  If Doscan = 1 Then
    Teller = Teller + 1
    If Teller = 10 Then
      Teller = 0
      Gosub Up
      Print_once = 1
    End If
  End If

  Debounce Enk3 , 0 , Menuhandler , Sub                     'enkoder button

  If Print_once = 1 Then Gosub Doprint
Loop

Doprint:
   Print_once = 0
   Ftx = Frx
   Rnr2 = 0
   If Frx > 1459975 And Frx < 1460000 Then
     Ftx = Frx - 6000
     Rnr = Frx - 1455625
     Rnr2 = Rnr / 125
     Tx_ctcss = Rctcss(rnr2)
     Rx_ctcss = Rctcss(rnr2)
     Fromrepeater = 1
   Else
     If Fromrepeater = 1 Then
       Fromrepeater = 0
       Tx_ctcss = 1
       Rx_ctcss = 1
     End If
   End If

   Frx1 = Frx / 10000
   Ftx1 = Ftx / 10000

   If Ftx < 1440000 Or Ftx > 1460000 Then Blocktx = 1 Else Blocktx = 0
    Print "AT+DMOSETGROUP=" ; 1 ; "," ; Ftx1 ; "," ; Frx1 ; "," ; Ctcode(tx_ctcss) ; "," ; Squ ; "," ; Ctcode(rx_ctcss)       ' ; "," ; 0        ' VHF simplex  wide
   'Print "AT+DMOSETVOLUME=" ; Volume
   'Print "AT+DMOSETMIC=" ; Mod_level ; "," ; 0 ; "," ; 0
   Gosub Printlcd
Return

Printlcd:
  Setfont Font10x16tt
  If Ftx < Frx Then
    If Tx_bit = 1 Then Repeatersign = "+" Else Repeatersign = "-"
  Else
    Repeatersign = " "
  End If

  If Tx_bit = 1 Then
    If Blocktx = 1 Then
      Lcdat 1 , 1 , "Error     " , Mfrq
    Else
      Lcdat 1 , 1 , Ftx1 ; Repeatersign ; " " , Mfrq
    End If
  Else
    Lcdat 1 , 1 , Frx1 ; Repeatersign ; " " , Mfrq
  End If


  Setfont Font5x5
  If Rnr2 > 0 Then
    Lcdat 3 , 1 , Rname(rnr2) ; " " ; Rcity(rnr2)
  Else
    Lcdat 3 , 1 , "                  "
  End If
  Setfont Font6x8

  If Band = 0 Then Label = Frxband1 / 10000 Else Label = Frxband0 / 10000
  Lcdat 5 , 1 , "JA7LGC 2M"

  Setfont Font5x5

  If Doscan = 0 Then Lbtxt = "OFF  " Else Lbtxt = "ON   "
  Lcdat 6 , 1 , "Scan:" ; Lbtxt ; "       " , Mscn

  If Mbnd = 1 Then
    If Band = 0 Then Lbtxt = "VHF  " Else Lbtxt = "UHF  "
    Lcdat 6 , 1 , "Band:" ; Lbtxt ; "       " , Mbnd
  End If

  If Msqu = 1 Then
    Lcdat 6 , 1 , "Squelch:" ; Squ ; "        " , Msqu
  End If

  If Mvol = 1 Then
    Lcdat 6 , 1 , "Volume:" ; Volume ; "         " , Mvol
  End If

  If Mmod = 1 Then
    Lcdat 6 , 1 , "Modulatie:" ; Mod_level ; "      " , Mmod
  End If

  If Mctt = 1 Then
    Lcdat 6 , 1 , "CTCSS TX:" ; Ctfreq(tx_ctcss) ; "    " , Mctt
  End If

  If Mctr = 1 Then
    Lcdat 6 , 1 , "CTCSS RX:" ; Ctfreq(rx_ctcss) ; "    " , Mctr
  End If

Return

Enkoder_sub1:
   Disable Interrupts
   If Enk2 = 1 And Enk1 = 0 Then Gosub Down
   If Enk2 = 0 And Enk1 = 1 Then Gosub Down
   Enable Interrupts
   Print_once = 1
Return

Enkoder_sub2:
   Disable Interrupts
   If Enk1 = 1 And Enk2 = 0 Then Gosub Up
   If Enk1 = 0 And Enk2 = 1 Then Gosub Up
   Enable Interrupts
   Print_once = 1
Return

Down:
  If Mfrq = 1 Then
    Frx = Frx - Step_freq
    If Band = 0 Then
      If Frx < 1440000 Then Frx = 1480000
    Else
      If Frx < 4300000 Then Frx = 4400000
    End If
  End If
  If Msqu = 1 Then
    Squ = Squ - 1
    If Squ = 255 Then Squ = 8
  End If
  If Mbnd = 1 Then
   If Band = 0 Then
     Frxband0 = Frx
     Frx = Frxband1
     Band = 1
   Else
     Frxband1 = Frx
     Frx = Frxband0
     Band = 0
   End If
   Mbnd = 0
   Mfrq = 1
   Menunr = 0
  End If
  If Mscn = 1 Then
   If Doscan = 0 Then Doscan = 1 Else Doscan = 0
   Mscn = 0
   Mfrq = 1
   Menunr = 0
   Teller = 0
  End If
  If Mmod = 1 Then
    Mod_level = Mod_level - 1
    If Mod_level = 255 Then Mod_level = 8
  End If
  If Mvol = 1 Then
    Volume = Volume - 1
    If Volume = 255 Then Volume = 8
  End If
  If Mctt = 1 Then
    Tx_ctcss = Tx_ctcss - 1
    If Tx_ctcss = 0 Then Tx_ctcss = 39
  End If
  If Mctr = 1 Then
    Rx_ctcss = Rx_ctcss - 1
    If Rx_ctcss = 0 Then Rx_ctcss = 39
  End If
Return

Up:
  If Mfrq = 1 Then
    Frx = Frx + Step_freq
    If Band = 0 Then
      If Frx > 1460000 Then Frx = 1440000
    Else
      If Frx > 4400000 Then Frx = 4300000
   End If
  End If
  If Msqu = 1 Then
    Squ = Squ + 1
    If Squ = 9 Then Squ = 0
  End If
  If Mbnd = 1 Then
   If Band = 0 Then
     Frxband0 = Frx
     Frx = Frxband1
     Band = 1
   Else
     Frxband1 = Frx
     Frx = Frxband0
     Band = 0
   End If
   Mbnd = 0
   Mfrq = 1
   Menunr = 0
  End If
  If Mscn = 1 Then
   If Doscan = 0 Then Doscan = 1 Else Doscan = 0
   Mscn = 0
   Mfrq = 1
   Menunr = 0
   Teller = 0
  End If
  If Mmod = 1 Then
    Mod_level = Mod_level + 1
    If Mod_level = 9 Then Mod_level = 0
  End If
  If Mvol = 1 Then
    Volume = Volume + 1
    If Volume = 9 Then Volume = 0
  End If
  If Mctt = 1 Then
    Tx_ctcss = Tx_ctcss + 1
    If Tx_ctcss = 40 Then Tx_ctcss = 1
  End If
  If Mctr = 1 Then
    Rx_ctcss = Rx_ctcss + 1
    If Rx_ctcss = 40 Then Rx_ctcss = 1
  End If
Return

Ledice_sub:
  If Ptt = 0 Then
    If Blocktx = 0 Then Tx_pin = 0
    Tx_bit = 1
    Tx_led = 1
    Rx_led = 0
  Else
    Tx_pin = 1
    Tx_bit = 0
    Rx_led = 0
    Tx_led = 0
  End If
Return

Menuhandler:
   Gosub Biper_s
   Incr Menunr
   If Menunr = 8 Then Menunr = 0
   Print_once = 1
   If Menunr = 0 Then Mfrq = 1 Else Mfrq = 0
   If Menunr = 1 Then Mscn = 1 Else Mscn = 0
   If Menunr = 2 Then Mbnd = 1 Else Mbnd = 0
   If Menunr = 3 Then Msqu = 1 Else Msqu = 0
   If Menunr = 4 Then Mvol = 1 Else Mvol = 0
   If Menunr = 5 Then Mmod = 1 Else Mmod = 0
   If Menunr = 6 Then Mctt = 1 Else Mctt = 0
   If Menunr = 7 Then Mctr = 1 Else Mctr = 0
Return
'********************************************

Biper_s:
   Bipbip = 0                                               'Beeper on Portd.0
   Waitms 50
   Bipbip = 1
   Waitms 50
Return

Fillcts:
  Ctcode(1) = "0000"
  Ctcode(2) = "0001"
  Ctcode(3) = "0002"
  Ctcode(4) = "0003"
  Ctcode(5) = "0004"
  Ctcode(6) = "0005"
  Ctcode(7) = "0006"
  Ctcode(8) = "0007"
  Ctcode(9) = "0008"
  Ctcode(10) = "0009"
  Ctcode(11) = "0010"
  Ctcode(12) = "0011"
  Ctcode(13) = "0012"
  Ctcode(14) = "0013"
  Ctcode(15) = "0014"
  Ctcode(16) = "0015"
  Ctcode(17) = "0016"
  Ctcode(18) = "0017"
  Ctcode(19) = "0018"
  Ctcode(20) = "0019"
  Ctcode(21) = "0020"
  Ctcode(22) = "0021"
  Ctcode(23) = "0022"
  Ctcode(24) = "0023"
  Ctcode(25) = "0024"
  Ctcode(26) = "0025"
  Ctcode(27) = "0026"
  Ctcode(28) = "0027"
  Ctcode(29) = "0028"
  Ctcode(30) = "0029"
  Ctcode(31) = "0030"
  Ctcode(32) = "0031"
  Ctcode(33) = "0032"
  Ctcode(34) = "0033"
  Ctcode(35) = "0034"
  Ctcode(36) = "0035"
  Ctcode(37) = "0036"
  Ctcode(38) = "0037"
  Ctcode(39) = "0038"

  Ctfreq(1) = "None "
  Ctfreq(2) = "67.0 "
  Ctfreq(3) = "71.9 "
  Ctfreq(4) = "74.4 "
  Ctfreq(5) = "77.0 "
  Ctfreq(6) = "79.7 "
  Ctfreq(7) = "82.5 "
  Ctfreq(8) = "85.4 "
  Ctfreq(9) = "88.5 "
  Ctfreq(10) = "91.5 "
  Ctfreq(11) = "94.8 "
  Ctfreq(12) = "97.4 "
  Ctfreq(13) = "100.0"
  Ctfreq(14) = "103.5"
  Ctfreq(15) = "107.2"
  Ctfreq(16) = "110.9"
  Ctfreq(17) = "114.8"
  Ctfreq(18) = "118.8"
  Ctfreq(19) = "123.0"
  Ctfreq(20) = "127.3"
  Ctfreq(21) = "131.8"
  Ctfreq(22) = "136.5"
  Ctfreq(23) = "141.3"
  Ctfreq(24) = "146.2"
  Ctfreq(25) = "151.4"
  Ctfreq(26) = "156.7"
  Ctfreq(27) = "162.2"
  Ctfreq(28) = "167.9"
  Ctfreq(29) = "173.8"
  Ctfreq(30) = "179.9"
  Ctfreq(31) = "186.2"
  Ctfreq(32) = "192.8"
  Ctfreq(33) = "203.5"
  Ctfreq(34) = "210.7"
  Ctfreq(35) = "218.1"
  Ctfreq(36) = "225.7"
  Ctfreq(37) = "233.6"
  Ctfreq(38) = "241.8"
  Ctfreq(39) = "250.3"
Return

Fillrepeaters:
  Rname(1) = "PI3UTR"
  Rname(2) = "NONE  "
  Rname(3) = "PI3ALK"
  Rname(4) = "PI3APM"
  Rname(5) = "PI3AMF"
  Rname(6) = "PI3ZUT"
  Rname(7) = "PI3BRD"
  Rname(8) = "PI3VLI"
  Rname(9) = "PI3RTD"
  Rname(10) = "PI3YMD"
  Rname(11) = "PI3EHV"
  Rname(12) = "PI3ZAZ"
  Rname(13) = "PI3APD"
  Rname(14) = "PI3FLD"
  Rname(15) = "PI3RAZ"
  Rname(16) = "PI3ALM"
  Rname(17) = "PI3ASD"

  Rcity(1) = "IJsselstein"
  Rcity(2) = "None       "
  Rcity(3) = "Alkmaar    "
  Rcity(4) = "Appingendam"
  Rcity(5) = "Amersfoort "
  Rcity(6) = "Zutphen    "
  Rcity(7) = "Breda      "
  Rcity(8) = "Vlissingen "
  Rcity(9) = "Rotterdam  "
  Rcity(10) = "IJmuiden   "
  Rcity(11) = "Eindhoven  "
  Rcity(12) = "Wormerveer "
  Rcity(13) = "Apeldoorn  "
  Rcity(14) = "Lelystad   "
  Rcity(15) = "Zoetermeer "
  Rcity(16) = "Almere     "
  Rcity(17) = "Amsterdam  "

  Rctcss(1) = 5
  Rctcss(2) = 1
  Rctcss(3) = 9
  Rctcss(4) = 7
  Rctcss(5) = 1
  Rctcss(6) = 1
  Rctcss(7) = 3
  Rctcss(8) = 9
  Rctcss(9) = 9
  Rctcss(10) = 9
  Rctcss(11) = 3
  Rctcss(12) = 9
  Rctcss(13) = 5
  Rctcss(14) = 5
  Rctcss(15) = 9
  Rctcss(16) = 1
  Rctcss(17) = 9
Return

$include "font5x5.font"
$include "font6x8.font"
$include "font8x8.font"
$include "font10x16tt.font"
'$include "font11x13.font"